Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mortbay.jetty.security
Class SslHttpChannelEndPoint

    java.lang.Object
      org.mortbay.io.nio.ChannelEndPoint
          org.mortbay.io.nio.SelectChannelEndPoint
              org.mortbay.jetty.nio.SelectChannelConnector.ConnectorEndPoint
                  org.mortbay.jetty.security.SslHttpChannelEndPoint

All Implemented Interfaces:
  java.lang.Runnable, EndPoint

    public class SslHttpChannelEndPoint

extends SelectChannelConnector.ConnectorEndPoint
implements java.lang.Runnable

SslHttpChannelEndPoint.

Author:
  Nik Gonzalez , Greg Wilkins

Nested Class Summary

Nested classes/interfaces inherited from class org.mortbay.io.nio.SelectChannelEndPoint
`SelectChannelEndPoint.IdleTask`

Field Summary
`protected javax.net.ssl.SSLSession` | `_session`

Fields inherited from class org.mortbay.io.nio.SelectChannelEndPoint
`_connection, _dispatched, _interestOps, _key, _manager, _readBlocked, _selectSet, _writable, _writeBlocked`

Fields inherited from class org.mortbay.io.nio.ChannelEndPoint
`_channel, _gather2, _local, _remote, _socket`

Constructor Summary
`SslHttpChannelEndPoint(Buffers buffers, java.nio.channels.SocketChannel channel, SelectorManager.SelectSet selectSet, java.nio.channels.SelectionKey key, javax.net.ssl.SSLEngine engine)`

Method Summary
`void` | `close()` Close any backing stream associated with the buffer
`protected void` | `doIdleExpired()`
`void` | `dump()`
`int` | `fill(Buffer buffer)` Fill the buffer from the current putIndex to it's capacity from whatever byte source is backing the buffer.
`void` | `flush()` Flush any buffered output.
`int` | `flush(Buffer buffer)` Flush the buffer from the current getIndex to it's putIndex using whatever byte sink is backing the buffer.
`int` | `flush(Buffer header, Buffer buffer, Buffer trailer)` Flush the buffer from the current getIndex to it's putIndex using whatever byte sink is backing the buffer.
`javax.net.ssl.SSLEngine` | `getSSLEngine()`
`protected void` | `idleExpired()`
`boolean` | `isAllowRenegotiate()`
`boolean` | `isBufferingInput()`
`boolean` | `isBufferingOutput()`
`boolean` | `isBufferred()`
`void` | `setAllowRenegotiate(boolean allowRenegotiate)` Set if SSL re-negotiation is allowed.
`void` | `shutdownOutput()` Shutdown any backing output stream associated with the endpoint
`java.lang.String` | `toString()`

Methods inherited from class org.mortbay.jetty.nio.SelectChannelConnector.ConnectorEndPoint
`undispatch`

Methods inherited from class org.mortbay.io.nio.SelectChannelEndPoint
`blockReadable, blockWritable, cancelIdle, dispatch, getConnection, getSelectSet, getTimeoutTask, run, scheduleIdle, scheduleWrite, setWritable`

Methods inherited from class org.mortbay.io.nio.ChannelEndPoint
`getChannel, getLocalAddr, getLocalHost, getLocalPort, getRemoteAddr, getRemoteHost, getRemotePort, getTransport, isBlocking, isOpen`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.lang.Runnable
`run`

Field Detail

### _session

    protected javax.net.ssl.SSLSession _session

Constructor Detail

### SslHttpChannelEndPoint

    public SslHttpChannelEndPoint(Buffers buffers,
                                  java.nio.channels.SocketChannel channel,
                                  SelectorManager.SelectSet selectSet,
                                  java.nio.channels.SelectionKey key,
                                  javax.net.ssl.SSLEngine engine)
                           throws javax.net.ssl.SSLException,
                                  java.io.IOException

Throws:
  `javax.net.ssl.SSLException`
  `java.io.IOException`

Method Detail

### isAllowRenegotiate

    public boolean isAllowRenegotiate()

  Returns:
    True if SSL re-negotiation is allowed (default false)

### setAllowRenegotiate

    public void setAllowRenegotiate(boolean allowRenegotiate)

  Set if SSL re-negotiation is allowed. CVE-2009-3555 discovered a vulnerability in SSL/TLS with re-negotiation. If your JVM does not have CVE-2009-3555 fixed, then re-negotiation should not be allowed.

  Parameters:
    `allowRenegotiate` - true if re-negotiation is allowed (default false)

### dump

    public void dump()

### idleExpired

    protected void idleExpired()

  Overrides:
    `idleExpired` in class `SelectChannelEndPoint`

### doIdleExpired

    protected void doIdleExpired()

### shutdownOutput

    public void shutdownOutput()
                        throws java.io.IOException

  Description copied from interface: `EndPoint`
  Shutdown any backing output stream associated with the endpoint

  Specified by:
    `shutdownOutput` in interface `EndPoint`
  Overrides:
    `shutdownOutput` in class `ChannelEndPoint`
  Throws:
    `java.io.IOException`

### close

    public void close()
               throws java.io.IOException

  Description copied from interface: `EndPoint`
  Close any backing stream associated with the buffer

  Specified by:
    `close` in interface `EndPoint`
  Overrides:
    `close` in class `SelectChannelConnector.ConnectorEndPoint`
  Throws:
    `java.io.IOException`

### fill

    public int fill(Buffer buffer)
             throws java.io.IOException

  Description copied from interface: `EndPoint`
  Fill the buffer from the current putIndex to it's capacity from whatever byte source is backing the buffer. The putIndex is increased if bytes filled. The buffer may chose to do a compact before filling.

  Specified by:
    `fill` in interface `EndPoint`
  Overrides:
    `fill` in class `ChannelEndPoint`
  Returns:
    an `int` value indicating the number of bytes filled or -1 if EOF is reached.
  Throws:
    `java.io.IOException`

### flush

    public int flush(Buffer buffer)
              throws java.io.IOException

  Description copied from interface: `EndPoint`
  Flush the buffer from the current getIndex to it's putIndex using whatever byte sink is backing the buffer. The getIndex is updated with the number of bytes flushed. Any mark set is cleared. If the entire contents of the buffer are flushed, then an implicit empty() is done.

  Specified by:
    `flush` in interface `EndPoint`
  Overrides:
    `flush` in class `SelectChannelEndPoint`
  Parameters:
    `buffer` - The buffer to flush. This buffers getIndex is updated.
  Returns:
    the number of bytes written
  Throws:
    `java.io.IOException`

### flush

    public int flush(Buffer header,
                     Buffer buffer,
                     Buffer trailer)
              throws java.io.IOException

  Description copied from interface: `EndPoint`
  Flush the buffer from the current getIndex to it's putIndex using whatever byte sink is backing the buffer. The getIndex is updated with the number of bytes flushed. Any mark set is cleared. If the entire contents of the buffer are flushed, then an implicit empty() is done. The passed header/trailer buffers are written before/after the contents of this buffer. This may be done either as gather writes, as a poke into this buffer or as several writes. The implementation is free to select the optimal mechanism.

  Specified by:
    `flush` in interface `EndPoint`
  Overrides:
    `flush` in class `SelectChannelEndPoint`
  Parameters:
    `header` - A buffer to write before flushing this buffer. This buffers getIndex is updated.
    `buffer` - The buffer to flush. This buffers getIndex is updated.
    `trailer` - A buffer to write after flushing this buffer. This buffers getIndex is updated.
  Returns:
    the total number of bytes written.
  Throws:
    `java.io.IOException`

### flush

    public void flush()
               throws java.io.IOException

  Description copied from interface: `EndPoint`
  Flush any buffered output. May fail to write all data if endpoint is non-blocking

  Specified by:
    `flush` in interface `EndPoint`
  Overrides:
    `flush` in class `ChannelEndPoint`
  Throws:
    `java.io.IOException`

### isBufferingInput

    public boolean isBufferingInput()

  Specified by:
    `isBufferingInput` in interface `EndPoint`
  Overrides:
    `isBufferingInput` in class `ChannelEndPoint`
  Returns:
    True if the endpoint has some buffered input data

### isBufferingOutput

    public boolean isBufferingOutput()

  Specified by:
    `isBufferingOutput` in interface `EndPoint`
  Overrides:
    `isBufferingOutput` in class `ChannelEndPoint`
  Returns:
    True if the endpoint has some buffered output data

### isBufferred

    public boolean isBufferred()

  Specified by:
    `isBufferred` in interface `EndPoint`
  Overrides:
    `isBufferred` in class `ChannelEndPoint`

### getSSLEngine

    public javax.net.ssl.SSLEngine getSSLEngine()

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `SelectChannelEndPoint`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1995-2010 Mort Bay Consulting. All Rights Reserved.